<?
class myBot extends Log
{
	
	private function __restart()
	{
		$this->_raw("QUIT :Rehashing.");
		fclose($this->_socket);
		exec("php bot.php &");
		exit;
	}

	function _open($_server, $_port, $_nick, $_user, $_realname, $_level)
	{
		$this->VERSION = $GLOBALS['_VERSION_'];
		$this->_server = $_server;
		$this->_port = $_port;
		$this->_nick = $_nick;
		$this->_user = $_user;
		$this->_realname = $_realname;
		$this->log_level = $_level;
		$this->printlog($this->log_level, "Conectando ...");
		$this->_socket = @fsockopen($this->_server, $this->_port, $this->sock_errno, $this->sock_errstr, 30);
		if($this->_socket)
		{
			$this->printlog($this->log_level, "Conectado.");
//			$this->_raw("nick ".$this->_nick);
			$this->_raw("user ".$this->_user." text text :".$this->_realname);
			$this->_raw("nick ".$this->_nick);
			$this->printlog($this->log_level, "nick -> ".$this->_nick);
			$this->printlog($this->log_level, "ident -> ".$this->_user);
			$this->buffer = @fgets($this->_socket, 20);
			$this->_pong();
		}
		else
		{
			$this->printlog($this->log_level, "Error al conectar.");
			exit();
		}

		return $this->_socket;
	}

	function _raw($_command)
	{
		return fwrite($this->_socket, $_command."\r\n");
	}

	function _privmsg($_who, $_txt)
	{
		$this->_raw("PRIVMSG ".$_who." :".$_txt);
	}

	function _join($_chan)
	{
		$this->printlog($this->log_level, "Entrando a ".$_chan);
		$this->_raw("JOIN ".$_chan);
	}
	function _part($_chan)
	{
		$this->printlog($this->log_level, "Saliendo de ".$_chan);
		$this->_raw("PART ".$_chan);
	}
	function _autojoin($chans)
	{
		$this->_channels = $chans;
		foreach($this->_channels as $chan)
		{
			$this->_join($chan);
		}
	}
	function _pong()
	{
		$buffer = explode(" ",$this->buffer);
		if(stristr($buffer[0],"PING"))
		{
			$this->_raw("PONG ".str_replace(':','',$buffer[1]));
//			print "\nPONG!!!!\n";
		}
	}
	function checkCMD()
	{
		global $owner_pass, $owner;
		$this->printlog($this->log_level,'');
		$buffer = str_replace("\r\n", "", $this->buffer);
		$buffer = explode(" ",$buffer);
		$CHAN = $buffer[2];
		$nick = explode("!", $buffer[0]);
		$nick = str_replace(":", "", $nick[0]);
		$CMD = str_replace(":", "", $buffer[3]);

		if(stristr($buffer[3], chr(01)))
		{
			$_cmd = str_replace(chr(01), "", $CMD);
			switch($_cmd)
			{
				case "VERSION":
				$this->_raw("NOTICE ".$nick." :".$this->VERSION);
				break;
			}
		}
		if($buffer[1] == "JOIN")
		{
			$_CHAN = substr($CHAN, 1);
			if((($this->_TXTFLOOD[$_CHAN] == "on")||(!isset($this->_TXTFLOOD[$_CHAN]))))
			{
				$this->JOINflood($buffer[0], $CHAN);
			}
		}

		if($this->CHECK_NS == "yes")
                {
			switch($buffer[1])
			{
				case "307":
					unset($this->CHECK_NS);
					$this->_is_id = "si";
//					print $_is_id;
					break;
				case "318":
					unset($this->CHECK_NS);
					$this->_is_id = "no";
//					print $_is_id;
					break;
			}
			return;
/*			if(isset($_is_id))
			{
				return $_is_id;
			}
*/
                 }


/* Comandos en orden de privilegios:
 *
 * 1. Se verifica si el usuario es OWNER del bot
 * 2. Se verifica si el usuario es ADMIN en el canal
 * 3. Se verifica si el usuario es ADMIN u OWNER
 * 4. Se verifica si el usuario es ACCESS, OWNER o ACCESS  en el canal
 * 5. Comandos para usuarios no-owner, no-access y no-admin
 * 
 */
		if($CHAN[0] == "#")
		{
			
			
			if($buffer[1] == "PRIVMSG")
			{
				if((($this->_TXTFLOOD[$CHAN] == "on")||(!isset($this->_TXTFLOOD[$CHAN]))))
				{
					$this->TXTflood($buffer[0], $CHAN);
				}
			}
			// Comandos para los OWNERs identificados
			if($this->is_owner($nick, $buffer[0]))
			{
				switch($CMD)
				{
					case "!del":
						Oracle::status();
						$this->_raw("NOTICE ".$nick." :".CHAdmin::chanadmin($CMD, $buffer[5], $CHAN, $buffer[4]));
						break;
					case "!add":
						Oracle::status();
						$this->_raw("NOTICE ".$nick." :".CHAdmin::chanadmin($CMD, $buffer[5], $CHAN, $buffer[4]));
						break;
					case "!cycle":
						$this->_raw("PART ".$CHAN);
						$this->_raw("JOIN ".$CHAN);
						break;
					case "!part":
						$this->_part($CHAN);
						break;
					case "!join":
						$this->_join($buffer[4]);
						break;
					case "!quit":
						$this->quit();
						break;
					case "!uptime":
						$this->_privmsg($CHAN, shell_exec("uptime"));
						break;
					case "!raw";
						$_tmp = $buffer[4]." ";
						for($_i = 5; isset($buffer[$_i]); $_i++)
						{
							$_tmp .= $buffer[$_i]." ";
						}
						$this->_raw($_tmp);
						break;
					case "!restart":
						$this->__restart();
						break;
				}
			}
			// Comandos para los admin de cada sala
			if(CHAdmin::is_identify($buffer[0], $nick) == "admin")
			{
				switch($CMD)
				{
					case "!del":
						Oracle::status();
						$this->_raw("NOTICE ".$nick." :".CHAdmin::chanadmin($CMD, $buffer[5], $CHAN, $buffer[4]));
						break;
					case "!add":
						Oracle::status();
						$this->_raw("NOTICE ".$nick." :".CHAdmin::chanadmin($CMD, $buffer[5], $CHAN, $buffer[4]));
						break;
				}
			}
			// Si es OWNER, ACCESS o ADMIN identificado
			if(($this->is_owner($nick, $buffer[0])||(CHAdmin::is_identify($buffer[0], $nick)))) //Para limitar solo a owner y admin (no access poner == admin
			{
				switch($CMD)
				{
					case "!flood":
						if(isset($buffer[4]))
						{
							if($buffer[4] == "on")
							{
								$this->_TXTFLOOD[$CHAN] = "on";
								$this->_raw("NOTICE ".$nick." :Proteccion anti-flood de texto ahora esta ON.");
//								print "FLOOD: ".$this->_TXTFLOOD[$CHAN]."\n";

							}
							if($buffer[4] == "off")
							{
								$this->_TXTFLOOD[$CHAN] = "off";
								$this->_raw("NOTICE ".$nick." :Proteccion anti-flood de texto ahora esta OFF.");
//								print "FLOOD: ".$this->_TXTFLOOD[$CHAN]."\n";
							}
						}
						break;
					case "!forget":
						if(isset($buffer[4]))
						{
							Oracle::status();
							$this->_raw("NOTICE ".$CHAN." :".Oracle::forget($buffer[4], $CHAN));
						}
						break;
					case "!list":
						{
							Oracle::status();
							$this->_raw("NOTICE ".$CHAN." :".Oracle::_list($CHAN));
						}
						break;
                                        case "!learn":
                                                if((isset($buffer[4]))&&(isset($buffer[5])))
                                                {
							Oracle::status();
                                                        $_entry = $buffer[5]." ";
                                                        for($_i = 6; isset($buffer[$_i]); $_i++)
                                                        {
                                                                $_entry .= $buffer[$_i]." ";
                                                        }
                                                        $this->_raw("NOTICE ".$CHAN." :".Oracle::learn($buffer[4], $CHAN, $nick, $_entry));
                                                }
                                                break;
					default:
						if(stristr($CMD, "!"))
						{
							CHAdmin::__actions($CHAN, $buffer[4], $CMD, $nick, $buffer[0]);
						}
				}
			}
			// Comandos para cualquier usuario
			switch($CMD)
			{
/*				case "!quote":
					$_fortunes = @shell_exec("fortune");
					if($_fortunes)
					{
						$this->_raw("PRIVMSG ".$CHAN." :".$_fortunes);
					}
					break;
*/
				case "!num":
					if((is_numeric($buffer[4]))&&($buffer[4] <= 9999999)&&($buffer[4] > 0))
					{
						$this->_raw("PRIVMSG ".$CHAN." :".$buffer[4].": ".shell_exec("./extras/numerador $buffer[4]"));
					}
					break;
				case "!define":
					if(isset($buffer[4]))
					{
						$n=strlen($buffer[0].$buffer[1].$buffer[2].$buffer[3]);
						$n=$n+4;
						$_TXT=substr($this->buffer,$n);
						$_TXT=rtrim($_TXT);
						$_defres = Google::_define($_TXT);
						if(!$_defres)
						{
							$this->_raw("NOTICE ".$CHAN." :No se encontraron definiciones para ".$_TXT.".");
						}
						else
						{
							 $this->_raw("NOTICE ".$CHAN." :".$_defres);
						}
					}
					break;
				case "!google":
					if(isset($buffer[4]))
					{
						$n=strlen($buffer[0].$buffer[1].$buffer[2].$buffer[3]);
						$n=$n+4;
						$_TXT=substr($this->buffer,$n);
						$_TXT=rtrim($_TXT);
						$_google = Google::_search($_TXT);
						if(!$_google)
						{
							$this->_raw("NOTICE ".$CHAN." :No se encontraron resultados para la busqueda ".$buffer[4].".");
						}
						else
						{
							$this->_raw("NOTICE ".$CHAN." :".$_google);
						}
					}
					break;
				case "!keygen":
					if(isset($buffer[4]))
					{
						$this->_raw("PRIVMSG ".$CHAN." :Usuario: ".$buffer[4]." Key: ".mircKG::keygen($buffer[4]));
					}
					break;
				case "??":
					if(isset($buffer[4]))
					{
						Oracle::status();
						$this->_raw("NOTICE ".$CHAN." :".Oracle::read($buffer[4], $CHAN));
					}
					break;
				case "!search":
					if(isset($buffer[4]))
					{
						Oracle::status();
						$this->_raw("NOTICE ".$CHAN." :".Oracle::search($buffer[4], $CHAN));
					}
					break;
				case "!identify":
					if(!CHADmin::is_identify($buffer[0], $nick))
					{
						$_Var = $this->check_ns_identify($nick);
//						print $_Var."\n";
						if(stristr($_Var, "si"))
						{
							$this->_raw("NOTICE ".$nick." :".CHAdmin::identify($nick, $buffer[0]));
						}
					}
					break;
				case "!suerte":
					$_luck_var = rand(0,5);
					if($_luck_var == 2)
					{
//						print "Sin suerte\n";
						$lucky_message = $nick.", lo siento, hoy no estas con suerte! :-(";
						$this->_raw("KICK ".$CHAN." ".$nick." :$lucky_message");
					}
					else
					{
						$this->_raw("PRIVMSG ".$CHAN." :$nick, hoy estas con suerte ;-)");
//						print "Con suerte\n";
					}
					break;
					
			}
		}
		// Comandos por privado
		else
		{
			switch($CMD)
			{
				case "identify":
					foreach($owner as $_niq)
					{
						if(strcmp($nick, $_niq)==0)
						{
							if(!$this->is_owner($nick, $buffer[0]))
							{
								if(strcmp(md5($buffer[4]), $owner_pass)==0)
								{
									$this->_privmsg($nick, "Password correcta. Ahora estas identificado.");
									$this->_status[$nick] = "identified";
									$this->_mask[$nick] = $buffer[0];
								}
								else
								{
									$this->_privmsg($nick, "Password incorrecta.");
								}
							}
						}
					}
			break;
			}
		}
	}
	function avoid()
	{
		$i = 0;
		while(!feof($this->_socket))
		{
			$this->buffer = @fgets($this->_socket, 4096);
			$this->_pong();
/*			print $this->CHECK_NS;
			if($this->CHECK_NS == "yes")
			{
				while(!stristr($this->buffer, ":End of /WHOIS list."))
				{
					$_buf = explode(" ", $this->buffer);
					print $this->buffer;
					if($_buf[1] == 307) { $this->tmp_identify = "ok"; }
				}
			}
			unset($this->CHECK_NS);
*/
			$this->checkCMD();
			if($i == 5)
			{
				$this->_raw("mode ".$GLOBALS['nick']." +Ri");
				if(isset($GLOBALS['nick_pass'])) { $this->ns_identify($GLOBALS['nick_pass']); }
				$this->_autojoin($GLOBALS['channels']);
			}

			$this->buffer = str_replace("\r\n","",$this->buffer);
			$i++;
		}
	}
	function ns_identify($pass)
	{
		$this->printlog($this->log_level, "identificado.");
		$this->_privmsg("NickServ", "identify ".$pass);
	}
	function quit()
	{
		$this->_raw("QUIT :Success.");
		fclose($this->_socket);
		exit();
	}
	function is_owner($nick, $mask)
	{
		if(($this->_status[$nick] == "identified")&&($this->_mask[$nick] == $mask))
		{
			return TRUE;
		}
		else return FALSE;
	}
	function TXTflood($_mask, $_chan)
	{
		$__mask = $_mask;
		$_mask = explode("@", $_mask);
		$_mask = $_mask[1];
		$_APODO = explode("!", $__mask);
		$_APODO = str_replace(":", "", $_APODO[0]);
		$lines = 4; $secs = 2; $warn = 1;
		if(!isset($this->lineas[$_mask][$_chan]))
		{
			$this->lineas[$_mask][$_chan] = 0;
		}
		$this->lineas[$_mask][$_chan]++;
		$_c = $this->lineas[$_mask][$_chan];
		$this->Tflood[$_mask][$_c] = $_APODO;
//		echo "$_mask lleva ".$this->lineas[$_mask][$_chan]." lineas en ".time()." (".$_chan.")\n";
		if((!isset($this->segundos[$_mask][$_chan]))||($this->segundos[$_mask][$_chan] == "-1"))
		{
			$this->segundos[$_mask][$_chan] = time();
		}
		if(($this->lineas[$_mask][$_chan] >= $lines)&&(time()-$this->segundos[$_mask][$_chan] <= $secs))
		{
//			$_APODO = explode("!", $__mask);
//			$_APODO = str_replace(":", "", $_APODO[0]);
//			$_ADDRESS = explode("@", $_mask);
//			$_ADDRESS = $_ADDRESS[1];
			$_L = $this->lineas[$_mask][$_chan];
			$_S = time()-$this->segundos[$_mask][$_chan];
			$_motivo = ":Flood Text. (".$_L.":".$_S.")";
			if($this->_WARN[$_mask][$_chan] == $warn)
			{
				$this->_raw("MODE ".$_chan." +b *!*@".$_mask);
				$this->_WARN[$_mask][$_chan] = 0;
			}
			else
			{
				$this->_WARN[$_mask][$_chan]++;
			}
//			print var_dump($this->Tflood[$_mask]);
			foreach($this->Tflood[$_mask] as $niq)
			{
//				print "KICK $_chan $niq $_motivo";
				$this->_raw("KICK ".$_chan." ".$niq." ".$_motivo);
			}
			$this->lineas[$_mask][$_chan] = 0;
			$this->segundos[$_mask][$_chan] = "-1";
		}
		if(($this->lineas[$_mask][$_chan] >= $lines)&&(time()-$this->segundos[$_mask][$_chan] >= $secs))
		{ 
			$this->lineas[$_mask][$_chan] = 0;
			$this->segundos[$_mask][$_chan] = "-1";
		}
	}
	function JOINflood($_mask, $_chan)
	{
//		print "verificando flood ..\n";
		$joins = 3; $secs = 3;
		$now = time();
		$_APODO = explode("!", $_mask);
		$_APODO = str_replace(":", "", $_APODO[0]);
		$_chan = str_replace(":", "", $_chan);
		$_ADDRESS = explode("@", $_mask);
		$_ADDRESS = $_ADDRESS[1];
		if(!isset($this->Jflood[$_ADDRESS][$_chan]))
		{
			$this->Jflood[$_ADDRESS][$_chan] = 0;
		}
		$this->Jflood[$_ADDRESS][$_chan]++;
		$_c = $this->Jflood[$_ADDRESS][$_chan];
		$this->Nflood[$_ADDRESS][$_c] = $_APODO;
		if(!isset($this->Tflood[$_ADDRESS][$_chan]))
		{
			$this->Tflood[$_ADDRESS][$_chan] = time();
		}
		if(($this->Jflood[$_ADDRESS][$_chan] >= $joins)&&($now-$this->Tflood[$_ADDRESS][$_chan] <= $secs))
		{
			$this->_raw("MODE ".$_chan." +b "."*!*@".$_ADDRESS);
			foreach($this->Nflood[$_ADDRESS] as $niq)
			{
				$this->_raw("KICK ".$_chan." ".$niq." :Join Flood.");
			}
			$this->Jflood[$_ADDRESS][$_chan] = 0;
			unset($this->Tflood[$_ADDRESS][$_chan]);
		}
		if(($this->Jflood[$_ADDRESS][$_chan] >= $joins)&&($now-$this->Tflood[$_ADDRESS][$_chan] >= $secs))
		{
			$this->Jflood[$_ADDRESS][$_chan] = 0;
			unset($this->Tflood[$_ADDRESS][$_chan]);
		}
	}
	function check_ns_identify($_nick)
	{
//		print "Chekeando identify en el whois ...\n";
		$this->CHECK_NS = "yes";
//		print $this->CHECK_NS." $_nick";
		$this->_raw("WHOIS ".$_nick);
		return $this->_is_id;

	}
}
